//
// glView.h
//
// The header file of the view for rendered image
//

#ifndef __GLVIEW_H__
#define __GLVIEW_H__

#include <FL/Fl.H>

#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "scene.h"

class CAniUI;

class CGLView : public Fl_Gl_Window
{
public:
	CGLView(int x, int y, int w, int h, const char *l, Scene* scn);

	void draw();
	int handle(int event);

	void refresh();

	void resizeWindow(int width, int height);

	void saveImage(char *iname);

	void setUI(CAniUI* ui) { m_pUI=ui; };
	CAniUI* getUI() { return m_pUI; };

	void setScene(Scene *scn);

private:
	int m_nWindowWidth, m_nWindowHeight;

	Scene *m_pScene;

	CAniUI *m_pUI;
	unsigned char *m_pBuf;
	bool m_bSizeChange;

	// static callback functions
	static void cb_exit(Fl_Widget* o, void* v);
};

#endif