// disable warning message about converting double constant to float constant
#pragma warning(disable:4244)
#pragma warning(disable:4305)

#include "modelerdll.h"
#include <math.h>
#include <stdlib.h>

#define BASE_ROTATION   1
#define RIGHT_ULEG_ROTATION 2
#define RIGHT_LLEG_ROTATION 3
#define LEFT_ULEG_ROTATION 4
#define LEFT_LLEG_ROTATION 5

#define RIGHT_UARM_ROTATION 6
#define RIGHT_LARM_ROTATION 7
#define LEFT_UARM_ROTATION 8
#define LEFT_LARM_ROTATION 9

#define RED_COLOR 10
#define GREEN_COLOR 11
#define BLUE_COLOR 12

#define RFOOT_ROTATION 13
#define LFOOT_ROTATION 14

#define TWIST   15
#define CURL    16
#define SPIN    17
#define NOD     18

#define LIGHT   19
#define LIGHTX  20
#define LIGHTY  21
#define LIGHTZ  22

#define MOODS   23

#define DETAILS	24	

#define MAX(x,y)  ( (x) < (y) ? (y) : (x) )
void drawBody();
void drawButt();
void drawRightLeg();
void drawUpperRightLeg();
void drawLowerRightLeg();
void drawLeftLeg();
void drawUpperLeftLeg();
void drawLowerLeftLeg();
void drawNeck();
void drawHead();
void drawRightArm();
void drawUpperRightArm();
void drawLowerRightArm();
void drawRightArm();
void drawUpperRightArm();
void drawLowerRightArm();
void drawLeftArm();
void drawUpperLeftArm();
void drawLowerLeftArm();
void drawHand();
void drawFinger();
void drawAntenna(int x);
void drawLeftFoot();
void drawRightFoot();
void drawEye();
void segment(double length, double radius);
void pentagon();
void drawMouth();
void drawNose();
void drawHat();

MODEL("Flick");

int angle;
int delta = 25;
int x ;
int antenna;
int uarm;
int larm;
int lfoot;

bool init(void *v)
{
	printf("init args : %s\n", (char*)v);

	menu( MOODS, "moods", 0, "Manual", "Happy", "Sad", "Mad", NULL);
    scale( BASE_ROTATION, "base rotation", 0.0, 360.0, 0.1, 10);
	scale( RIGHT_ULEG_ROTATION, "right leg rotation", 25.0, -25.0, 0.1, 13.4);
	scale( RIGHT_LLEG_ROTATION, "right lower leg rotation", 25.0, -25.0, 0.1, -5.7);
	scale( LEFT_ULEG_ROTATION, "left leg rotation", 25.0, -25.0, 0.1, -13.4);
	scale( LEFT_LLEG_ROTATION, "left lower leg rotation", 25.0, -25.0, 0.1, 3.0);
    
	scale( RIGHT_UARM_ROTATION, "right arm rotation", 90.0, -90.0, 0.1, 25.0);
	
	scale( RIGHT_LARM_ROTATION, "right lower arm rotation", 90.0, -90.0, 0.1, 25.0);
	scale( LEFT_UARM_ROTATION, "left arm rotation", 90.0, -90.0, 0.1, 25.0);
	scale( LEFT_LARM_ROTATION, "left lower arm rotation", 90.0, -90.0, 0.1, 25.0);

	scale( RFOOT_ROTATION, "right foot rotation", 80, 100, 1, 80);
	scale( LFOOT_ROTATION, "left foot rotation", 80, 100, 1, 80);
    
//	scale( RED_COLOR, "red", 0.0, 1.0, 0.01, 0.47 );
//	scale( GREEN_COLOR, "green", 0.0, 1.0, 0.01, 0.53 );
//  scale( BLUE_COLOR, "blue", 0.0, 1.0, 0.01, 0.93 );

	scale( DETAILS, "level of detail", 0, 10, 5, 5);

	scale( TWIST, "twist", -45.0, 45.0, 0.5, 32.0 );
    scale( CURL, "curl", -90.0, 90.0, 0.5, 13.5 );
    scale( SPIN, "spin", 0.0, 360.0, 1.0, 306.0 );
    scale( NOD, "nod", -60.0, 60.0, 0.5, 12.5 );

//	scale( LIGHT, "light", 0.0, 1.0, 0.1, 0.5 );
	scale( LIGHTX, "lightx", -10.0, 10.0, 0.1, 10.0 );
	scale( LIGHTY, "lighty", -10.0, 10.0, 0.1, 10.0 );
	scale( LIGHTZ, "lightz", -10.0, 10.0, 0.1, 10.0 );

	x = get_control_i(RIGHT_UARM_ROTATION);
	angle = get_control_i(RIGHT_UARM_ROTATION);
	antenna = get_control_i(TWIST);
	lfoot = get_control_i(LFOOT_ROTATION);
	
	return true;
}



void redraw(int drawmode)
{
	
	GLfloat ambient[] = { 0.0, 0.0, 0.0, 0.0 };
    GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
    GLfloat specular[] = { 1.0, 1.0, 1.0, 1.0 };
   // GLfloat shininess[] = { 100.0};
    GLfloat position[] = { (GLfloat) get_control_d(LIGHTX), (GLfloat) get_control_d(LIGHTY), (GLfloat) get_control_d(LIGHTZ), 1.0f };
	
	glEnable( GL_LIGHTING );
	glEnable( GL_LIGHT1 );

	glDisable( GL_LIGHT0);

	glLightfv( GL_LIGHT1, GL_POSITION, position );
	glLightfv( GL_LIGHT1, GL_AMBIENT, ambient );
	glLightfv( GL_LIGHT1, GL_SPECULAR, specular );
	glLightfv( GL_LIGHT1, GL_DIFFUSE, diffuse );
	
	
    /* define the viewing transform:  orient the model so that +z is
       up and +x is to the right. */
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
	glTranslated( 0.0, -4.0, -20.0 );
    glRotated( -90.0, 1.0, 0.0, 0.0 );

    /* turn the whole assembly around the z-axis. */
    glRotated( get_control_d( BASE_ROTATION ), 0.0, 0.0, 1.0 );

  
	/*double x = get_control_d(LIGHT);
	ambient_color(0, 0, 0);
	GLfloat light_position[] = { (GLfloat)get_control_d(LIGHTX), -(GLfloat)get_control_d(LIGHTY), (GLfloat)get_control_d(LIGHTZ), 0.0f };
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);*/

	//diffuse_color(get_control_d(RED_COLOR), get_control_d(GREEN_COLOR), get_control_d(BLUE_COLOR));
	diffuse_color (0.47, 0.53, 0.93);

	glPushMatrix();
		glTranslated( 0.0, 0.0, 4 );
		drawBody();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-2, 0, 4);
		pentagon();
	glPopMatrix();

	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT1);
}

void drawBody()
{
	glPushMatrix();
		glScalef(1.0, 1.0, 1.2);
		cylinder(1.5, 0.15, 0.35);
	glPopMatrix();

	glPushMatrix();
		glTranslated( 0.0, 0.0, 0.0);
		glScalef(1.0, 1.0, 1.0);
		sphere(0.15);
	glPopMatrix();

	glPushMatrix();
		glTranslated(0,0,1.8);
		glScalef(1, 1, 1);
		sphere(0.35);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.0, 0.8, -0.2);	
		drawButt();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-0.08, 0.0, 0.7);
		drawRightArm();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.6, 0.0, 0.7);
		drawLeftArm();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.0, 0.0, 2.0);
		drawNeck();
	glPopMatrix();

}

void drawButt()
{
	glPushMatrix();
		glRotated(350, 1, 0, 0);
	
		glPushMatrix();
			glScalef(0.8, 1.2, 0.8);
			sphere(0.8);
		glPopMatrix();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.0, -0.7, -2.2);
		drawRightLeg();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.5, -0.7, -2.2);
		drawLeftLeg();
	glPopMatrix();

}

void drawRightLeg(){
	glPushMatrix();
		drawUpperRightLeg();		
	glPopMatrix();
}

void drawUpperRightLeg(){
	glTranslatef(-0.25, 0.0, 2.0);

	glPushMatrix();
	glRotatef(get_control_d(RIGHT_ULEG_ROTATION), 1.0, 0.0, 0.0);
	
	
	if(get_control_d(DETAILS) >= 5) {
		sphere(0.1);
		glTranslatef(0.0, 0.0, -2.0);
		cylinder(2, 0.2, 0.1);

		glPushMatrix();
			glTranslated(0,0,0);
			glScalef(1, 1, 1);
			sphere(0.2);
		glPopMatrix();
	
		glPushMatrix();
			glTranslatef(0.0, 0.0, -2);
			drawLowerRightLeg();
		glPopMatrix();

	}
	else {

		glTranslatef(0.0, 0.0, -4.0);
		cylinder(4, 0.3, 0.2);
		glTranslatef(0.0, 0.0, -0.35);
		drawRightFoot();
		
	}
	
	glPopMatrix();

}

void drawLowerRightLeg(){

	glTranslatef(0.0, 0.0, 2);
	glRotatef(get_control_d(RIGHT_LLEG_ROTATION), 1.0, 0.0, 0.0);

//	glPushMatrix();
//		glRotatef(-get_control_d(RIGHT_ULEG_ROTATION), 0.0, 1.0, 0.0);
		glTranslatef(0.0, 0.0, -2);
		cylinder(2, 0.2, 0.1);

		glPushMatrix();
			glTranslated(0,0,0);
			glScalef(1, 1, 1);
			sphere(0.2);
		glPopMatrix();

		glPushMatrix();
			glTranslatef(0.0, 0.0, -0.35);
			drawRightFoot();
		glPopMatrix();

//	glPopMatrix();
}

void drawRightFoot(){

	// drawing the connecting stem to foot
	cylinder(0.25, 0.1, 0.1);
	sphere(0.1);
	
	glPushMatrix();
		//glRotatef(80, 1, 0, 0);
		glRotatef(get_control_d(RFOOT_ROTATION), 1, 0, 0);
		glScalef(1.0, 0.5, 1.0);
		cylinder(0.8, 0.15, 0.3);

		glTranslatef(0.0, 0.0, 0.8);
		sphere(0.3);
	glPopMatrix();
}

void drawLeftLeg(){
	glPushMatrix();
		drawUpperLeftLeg();		
	glPopMatrix();
}

void drawUpperLeftLeg(){
	glTranslatef(-0.25, 0.0, 2.0);

	glPushMatrix();
	glRotatef(get_control_d(LEFT_ULEG_ROTATION), 1.0, 0.0, 0.0);
	

	if(get_control_d(DETAILS) >= 5) {
		sphere(0.1);
		glTranslatef(0.0, 0.0, -2.0);
		cylinder(2, 0.2, 0.1);

		glPushMatrix();
			glTranslated(0,0,0);
			glScalef(1, 1, 1);
			sphere(0.2);
		glPopMatrix();
	
		glPushMatrix();
			glTranslatef(0.0, 0.0, -2);
			drawLowerLeftLeg();
		glPopMatrix();
	}
	else {

		glTranslatef(0.0, 0.0, -4.0);
		cylinder(4, 0.3, 0.2);
		glTranslatef(0.0, 0.0, -0.35);
		drawLeftFoot();
		
	}

	glPopMatrix();

}

void drawLowerLeftLeg(){

	glTranslatef(0.0, 0.0, 2);
	glRotatef(get_control_d(LEFT_LLEG_ROTATION), 1.0, 0.0, 0.0);

	//glPushMatrix();
	  //glRotatef(-get_control_d(LEFT_ULEG_ROTATION), 0.0, 1.0, 0.0);
		glTranslatef(0.0, 0.0, -2);
		cylinder(2, 0.2, 0.1);

		glPushMatrix();
			glTranslated(0,0,0);
			glScalef(1, 1, 1);
			sphere(0.2);
		glPopMatrix();

		glPushMatrix();
			glTranslatef(0.0, 0.0, -0.35);
			drawLeftFoot();
		glPopMatrix();

	//glPopMatrix();
}

void drawLeftFoot(){
	
	// drawing the connecting stem to foot
	cylinder(0.25, 0.1, 0.1);
	sphere(0.1);
	
	glPushMatrix();
		//glRotatef(80, 1, 0, 0);
		if (get_control_d(MOODS) != 3) // not mad
			glRotatef(get_control_d(LFOOT_ROTATION), 1, 0, 0);
		else{
			glRotatef((80 + 20*sin(get_time())), 1, 0, 0);
		}
		glScalef(1.0, 0.6, 1.0);
		cylinder(0.8, 0.15, 0.3);

		glTranslatef(0.0, 0.0, 0.8);
		sphere(0.3);
	glPopMatrix();

}

void drawNeck(){
	cylinder(0.35, 0.15, 0.15);
	glPushMatrix();
		glTranslated(0.0, 0.0, 0.65);
		drawHead();
	glPopMatrix();
}

void drawHead(){

	if (get_control_d(MOODS) == 2){ //sad
		glTranslated(0, 0, 0);
		glRotatef(25, 1, 0, 0);
		glRotatef(30*sin(get_time()), 0, 1, 0);
			
	}
	glPushMatrix();
		glScalef(1.0, 0.8, 0.8);
		sphere(0.5);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-0.2, 0.0, 0.4);
		drawAntenna(0);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.2, 0.0, 0.4);
		drawAntenna(1);
	glPopMatrix();

	if(get_control_d(DETAILS) == 10){
		glPushMatrix();
			glTranslatef(0.0, 0.0, 0.4);
			drawHat();
		glPopMatrix();
	}
	 	
	glPushMatrix();
		glTranslatef(-.3, -0.3, 0.25);
		drawEye();
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.3, -0.3, 0.25);
		drawEye();
	glPopMatrix();	


	glPushMatrix();
		glTranslatef(0, -0.3, 0);
		drawNose();
	glPopMatrix();	

	glPushMatrix();
		glTranslatef(0, -0.3, -0.2);
		drawMouth();
	glPopMatrix();	

}
void drawHat() {

	glPushMatrix();
		diffuse_color(1.0, 1.0, 0);
		cylinder(0.1, 0.3, 0.3);
		glTranslatef (0.0, 0.0, 0.1);
		cylinder(0.3, 0.6, 0.001);
		glTranslatef(0.0, 0.0, 0.3);
		glScalef(1,1, 0.1);
		sphere(0.6);
	glPopMatrix();

}

void drawNose(){
	glPushMatrix();
		diffuse_color(1,1,1);
		sphere(0.12);
	glPopMatrix();
}


void drawMouth(){
	
	int mood_index = (int)get_control_d(MOODS);

	if(mood_index == 1) //draw sad face
	{
		glPushMatrix();
			diffuse_color(1,1,1);
			glScalef(1,1, 0.3);
			sphere(0.2);
		glPopMatrix();
	}
	else if (mood_index == 2) //draw mad face
	{	
		glPushMatrix();
			diffuse_color(1,1, 0);
			sphere(0.1);
		glPopMatrix();

	}
	else // draw happy face
	{
		glPushMatrix();
			diffuse_color(1,0,0);
			glTranslatef(0.2, 0, 0);
			glRotated(-90,  0, 1, 0);
			
			cylinder(0.4, 0.05, 0.05);
		
		glPopMatrix();
	}



}
void drawEye(){
	glPushMatrix();	
		diffuse_color(1, 1, 1);
		glScalef(1, 0.8, 1);
		sphere(0.25);
	glPopMatrix();

	glPushMatrix();
		diffuse_color(0.0, 0.5, 0.5);
		glTranslatef(0.0, -0.15, 0.0);
		sphere(0.1);
	glPopMatrix();
}

void drawAntenna(int x){

//    int lighting;
    int i, j=0;
    double twist, curl, spin, nod;
    double length;
    double time = get_time();

	double r = rand() % 256;
	double g = rand() % 256;
	double b = rand() % 256;

	diffuse_color(r/256, b/256, g/256);
    
	
	if (get_control_d(MOODS) == 0){//none
	
		twist = get_control_d( TWIST );
		curl = get_control_d( CURL );
		spin = get_control_d( SPIN );
		nod = get_control_d( NOD );
	} else if (get_control_d(MOODS) == 1){ //happy
		//twist = get_control_d( TWIST );
		curl = get_control_d( CURL );
		spin = get_control_d( SPIN );
		twist = 45.0 * sin( MAX(time-j,0.0) / 10.0 * M_PI * 2.0 );
	    //curl = 60.0 * sin( MAX(time-j,0.0) / 10.0 * M_PI * 4.0 / 7.0 );
	    nod = 30.0 * sin( MAX(time-j,0.0) / 10.0 * M_PI * 3.0 / 2.0 );
		//spin = get_control_d( SPIN );
	} else if (get_control_d(MOODS) == 2){ //sad
		twist = 6.0;
		curl = -27.5;
		spin = 360;
		nod = -21.5;
	} else if (get_control_d(MOODS) == 3){ // mad
		nod = (x==1) ? 30 : -30;
		twist = 0;
		curl = 0;
		spin = 0;
	}

    glRotated( spin, 0.0, 0.0, 1.0 );
   
	glPushMatrix();
		if (get_control_d(MOODS) == 3 )
			glRotated( nod, 0.0, 1.0, 0.0 );
		else
			glRotated( nod, 1.0, 0.0, 0.0);

		length = 0.25;
		
		for ( i = 0; i < 8; ++i )
		{
			glPushMatrix();
			segment( length, 0.05 );
			glTranslated( 0.0, 0.0, length );
			length *= 0.95;
			
			glRotated( twist, 0.0, 0.0, 1.0 );
			glRotated( curl, 1.0, 0.0, 0.0 );
		}
		
		for ( i = 0; i < 8; ++i )
			glPopMatrix();

	glPopMatrix();
 
}


void drawRightArm(){
	glPushMatrix();
		drawUpperRightArm();		
	glPopMatrix();
}

void drawUpperRightArm(){
	
	glPushMatrix();
	glTranslatef(-0.25, 0.0, 1);
	if (get_control_d(MOODS) == 0)
		glRotatef(get_control_d(RIGHT_UARM_ROTATION), 1.0, 0.0, 0.0);
	else if (get_control_d(MOODS) == 1){ // happy
		if (x <130){
			glRotatef(x, 0.0, 1.0, 0.0);
			x = x + 10;
		}
		else{
			x = 130;
			glRotatef(x, 0.0, 1.0, 0.0);
		} 
	}else if (get_control_d(MOODS) == 2) {// sad
	
	}else if (get_control_d(MOODS) == 3) { //mad
		glRotatef(50, 0.0, 1.0, 0.0);			
	}
	
	
		glTranslatef(0.0, 0.0, -1);
		
		if(get_control_d(DETAILS) >= 5)
			cylinder(1, 0.15, 0.05);
		else
			cylinder(1, 0.15, 0.10);
		if(get_control_d(DETAILS) >= 5) {
			glPushMatrix();
				glTranslated(0,0,0);
				glScalef(1, 1, 1);
				sphere(0.15);
			glPopMatrix();
		}
	
		glPushMatrix();
			glTranslatef(0.0, 0.0, -1.0);
			drawLowerRightArm();
		glPopMatrix();
	
		
	glPopMatrix();
	
}

void drawLowerRightArm(){
	//glPushMatrix();
	glTranslatef(0.0, 0.0, 1.0);
	glPushMatrix();
	glRotatef(get_control_d(RIGHT_LARM_ROTATION), 1.0, 0.0, 0.0);
			
	if (get_control_d(MOODS) == 0){
//		glRotatef(-get_control_d(RIGHT_UARM_ROTATION), 0.0, 1.0, 0.0);
	}
	else if (get_control_d(MOODS) == 1){
		//glRotatef(-get_control_d(RIGHT_UARM_ROTATION), 0.0, 1.0, 0.0);
		if (x >= 130){
			glRotatef(angle, 0.0, 1.0, 0.0);
			if (angle <= 10 || angle >= 45)
				delta = -(delta);
			angle = angle + delta;
		}
	}else if (get_control_d(MOODS) == 2){
		
	}else if (get_control_d(MOODS) == 3){
		glRotatef(-80, 0.0, 1.0, 0.0);
	}

	glTranslatef(0.0, 0.0, -1.0);
	if(get_control_d(DETAILS) >= 5) {
		cylinder(1, 0.10, 0.03);
	}
	else
		cylinder(1, 0.10, 0.10);

	glPopMatrix();
	//glPopMatrix();
}

void drawLeftArm(){
	glPushMatrix();
		drawUpperLeftArm();		
	glPopMatrix();
}

void drawUpperLeftArm(){
	
	glPushMatrix();
	glTranslatef(-0.25, 0.0, 1);

	if (get_control_d(MOODS) == 0)
		glRotatef(get_control_d(LEFT_UARM_ROTATION), 1.0, 0.0, 0.0);
	else if (get_control_d(MOODS) == 1){ // happy
	 	glRotatef(get_control_d(LEFT_UARM_ROTATION), 1.0, 0.0, 0.0);
	}else if (get_control_d(MOODS) == 2) {// sad
	
	}else if (get_control_d(MOODS) == 3) { //mad
		glRotatef(-50, 0.0, 1.0, 0.0);			
	}

		glTranslatef(0.0, 0.0, -1);
		if(get_control_d(DETAILS) >= 5)
			cylinder(1, 0.15, 0.05);
		else
			cylinder(1, 0.15, 0.10);

		if(get_control_d(DETAILS) >= 5) {

			glPushMatrix();
				glTranslated(0,0,0);
				glScalef(1, 1, 1);
				sphere(0.15);
			glPopMatrix();
		}
	
		glPushMatrix();
			glTranslatef(0.0, 0.0, -1.0);
			drawLowerLeftArm();
		glPopMatrix();

	glPopMatrix();
	
}

void drawLowerLeftArm(){
		glTranslatef(0.0, 0.0, 1.0);
		glPushMatrix();
		glRotatef(get_control_d(LEFT_LARM_ROTATION), 1.0, 0.0, 0.0);

		if (get_control_d(MOODS) == 0){
//				glRotatef(-get_control_d(LEFT_UARM_ROTATION), 0.0, 1.0, 0.0);
		}
			else if (get_control_d(MOODS) == 1){
				glRotatef(-get_control_d(LEFT_UARM_ROTATION), 0.0, 1.0, 0.0);
			}else if (get_control_d(MOODS) == 2){

			}else if (get_control_d(MOODS) == 3){
				glRotatef(80, 0.0, 1.0, 0.0);
			}

			glTranslatef(0.0, 0.0, -1.0);
			if(get_control_d(DETAILS) >= 5)
				cylinder(1, 0.10, 0.03);	
			else
				cylinder(1, 0.10, 0.10);
			
			glTranslatef(0, 0, -0.15);
	//		drawHand();
		glPopMatrix();
}

void drawHand()
{
	glPushMatrix();
		glScalef(0.7, 0.7, 1);
		sphere(0.2);
	glPopMatrix();
	
	glTranslatef(0.0, 0.0, -0.5);
	double y = -0.07;
	double delta = 0.07;
	for (int i = 0; i< 3; i++)
	{
		glPushMatrix();
			glTranslatef(0, y, 0);
			drawFinger();
		glPopMatrix();
		y += delta;
	}
}

void drawFinger()
{		
	cylinder(0.3, 0.03, 0.04);
	sphere(0.04);
}

void segment( double length, double radius )
{
    //diffuse_color( 0.5, 0.5, 0.5 );
    cylinder( length, radius, radius );
    glPushMatrix();
    glTranslated( 0.0, 0.0, length );
    //diffuse_color( 0.0, 0.3, 0.8 );
    sphere( radius );
    glPopMatrix();
}

void pentagon(){
	int c[5];
	int i;
	double p1x, p1y, p2x, p2y;
	for (i= 0; i<5; i++)
		c[i] = 360/5*i;

	for (i=0; i<5; i++)
	{
		p1x = cos(c[i] * 3.14 / 180);
		p1y = sin(c[0] * 3.14 / 180);
		if (i==4){
			p2x = cos(c[0] * 3.14 / 180);
			p2y = sin(c[0] * 3.14 / 180);
		}else{
			p2x = cos(c[i+1] * 3.14 / 180);
			p2y = sin(c[i+1] * 3.14 / 180);
		}
		triangle(0,0,0, p1x,p1y,0, p2x, p2y, 0); 
	}


}
